﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private fSocket As Socket
	Private fAsyncStrream As AsyncStreams
	Private fLabelState As Label
	Private fIsConnected As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(aLabelState As Label)
	fLabelState=aLabelState
End Sub

'show if connected to the B4A's device or not
public Sub setState(aIsConnected As Boolean)
	fIsConnected=aIsConnected
	If fIsConnected Then
		fLabelState.Text="Connected"
	Else
		fLabelState.Text="Not Connected"
	End If
End Sub

'connect to the b4a's device
public Sub connect(aip As String)
	setState(False)
	If fAsyncStrream.IsInitialized Then
		fAsyncStrream.Close
	End If
	If fSocket.IsInitialized Then
		fSocket.Close
	End If
	fSocket.Initialize("socket")
	fSocket.Connect(aip,51040,0)
	wait for socket_connected(aSuccessfull As Boolean)
	If aSuccessfull Then
		setState(True)
		fAsyncStrream.InitializePrefix(fSocket.InputStream,True,fSocket.OutputStream,"stream")
	End If
End Sub

private Sub stream_newData(aBuffer() As Byte)
	Dim ser As B4XSerializator
	Dim m As TMessage
	m=ser.ConvertBytesToObject(aBuffer)
	Select Case m.fCommand
		Case "image"
			sendImage(m.fFileName)
	End Select
End Sub

Private Sub stream_Terminated
	setState(False)
End Sub

Private Sub	stream_error
	stream_Terminated
End Sub
'send message (cs) to the b4A device if connected

Sub sendCS(adata As List)
	If fIsConnected Then
		Dim ser As B4XSerializator
		Dim m As TMessage
		m.Initialize
		m.fCommand="cs"
		m.fCS=adata
		m.fFileName=""
		m.fBitmap=Array As Byte()
		Dim b() As Byte=ser.ConvertObjectToBytes(m)
		fAsyncStrream.write(b)
	End If
End Sub

'send message (cs) to the b4A device if connected
Sub sendImage(afilename As String)
	If fIsConnected Then
		Dim ser As B4XSerializator
		Dim m As TMessage
		m.Initialize
		m.fCommand="image"
		m.fCS.Initialize
		m.fFileName=afilename
		Dim bmp As Image=fx.LoadImageSample("",afilename,1000,1000)
		Dim out As OutputStream
		out.InitializeToBytesArray(0)
		bmp.WriteToStream(out)
		m.fBitmap=out.ToBytesArray
		out.Close
		Dim b() As Byte=ser.ConvertObjectToBytes(m)
		fAsyncStrream.write(b)
	End If
End Sub