﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.3
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub

'json utilities
public Sub mapFromJsonString(astring As String) As Map
	Try
		Dim jp As JSONParser
		jp.Initialize(astring)
		Return jp.NextObject
	Catch
		Log(LastException.Message)
		Return CreateMap()
	End Try
End Sub

public Sub listFromJsonString(aString As String) As List
	Try
		Dim jp As JSONParser
		jp.Initialize(aString)
		Return jp.NextArray
	Catch
		Log(LastException.Message)
		Dim l As List
		l.Initialize
		Return l
	End Try
End Sub

public Sub mapFromJsonFile(aDirName As String,aFileName As String) As Map
	Try
		Return mapFromJsonString(File.ReadString(aDirName,aFileName))
	Catch
		Log(LastException.Message)
		Return CreateMap()
	End Try
End Sub

public Sub listFromJsonFile(aDirName As String,aFileName As String) As List
	Try
		Return listFromJsonString(File.ReadString(aDirName,aFileName))
	Catch
		Log(LastException.Message)
		Dim l As List
		l.Initialize
		Return l
	End Try
End Sub

public Sub maptToJsonString(avalue As Map,aindent As Int) As String
	Try
		Dim jg As JSONGenerator
		jg.Initialize(avalue)
		If aindent=0 Then
			Return jg.ToString
		Else
			Return jg.ToPrettyString(aindent)
		End If
	Catch
		Log(LastException.Message)
		Return "{}"
	End Try
End Sub

public Sub listToJsonString(avalue As List,aindent As Int) As String
	Try
		Dim jg As JSONGenerator
		jg.Initialize2(avalue)
		If aindent=0 Then
			Return jg.ToString
		Else
			Return jg.ToPrettyString(aindent)
		End If
	Catch
		Log(LastException.Message)
		Return "[]"
	End Try
End Sub

public Sub mapToJsonFile(avalue As Map,aDirName As String,aFileName As String,aindent As Int)
	Try
		File.WriteString(aDirName,aFileName,maptToJsonString(avalue,aindent))
	Catch
		Log(LastException.Message)
	End Try
End Sub

public Sub listToJsonFile(avalue As List,aDirName As String,aFileName As String,aindent As Int)
	Try
		File.WriteString(aDirName,aFileName,listToJsonString(avalue,aindent))
	Catch
		Log(LastException.Message)
	End Try
End Sub

